;    awguilayout.pbi
;    Version 0.8 [2012/05/21]
;    Copyright (C) 2012 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

;{ Fixes for Linux
CompilerIf #PB_Compiler_OS = #PB_OS_Linux
	ImportC "-gtk"
  	g_signal_connect_data(*widget,signal.p-utf8,*fn,*vdata,destroy)
	EndImport

	ProcedureC ____AWPB_GUILO_GtkWidgets_CB_SSR_TG(*label.GtkWidget, *allocation.GtkAllocation, *dummy)
  	gtk_widget_set_size_request_(*label, *allocation\width - 2, -1)
	EndProcedure
	ProcedureC ____AWPB_GUILO_GtkWidgets_CB_SSR_FG(*label.GtkWidget, *allocation.GtkAllocation, *daten)
		gtk_widget_set_size_request_(gtk_frame_get_label_widget_(*label), *allocation\width - 2, -1)
	EndProcedure
	
	Procedure AWPB_GUILO_Fix_TextGadget_Resize(GadgetID.i, EnableWordWrap.b)
		gtk_label_set_line_wrap_(GadgetID(GadgetID), EnableWordWrap)
		g_signal_connect_data(GadgetID(GadgetID), "size-allocate", @____AWPB_GUILO_GtkWidgets_CB_SSR_TG(), #Null, 0)
	EndProcedure 
	Procedure AWPB_GUILO_Fix_Frame3DGadget_Resize(GadgetID.i)
		g_signal_connect_data(GadgetID(GadgetID), "size-allocate", @____AWPB_GUILO_GtkWidgets_CB_SSR_FG(), #Null, 0)
	EndProcedure  
CompilerEndIf
;}
;{ Flags; public and internal
#AWPB_GUILO_SIZER_VBOX								=	$00000001
#AWPB_GUILO_SIZER_HBOX								=	$00000002
#AWPB_GUILO_SIZER_GADGET							=	$00000004
#AWPB_GUILO_SIZER_SPACER							=	$00000008
#AWPB_GUILO_SIZER_SIZER								=	$00000010
#AWPB_GUILO_SIZER_FRAME								=	$00000020
#AWPB_GUILO_SIZER_PARENT_WINDOW				=	$00000040
#AWPB_GUILO_SIZER_PARENT_CONTAINER		=	$00000080
#AWPB_GUILO_SIZER_PARENT_FRAME				=	$00000100
#AWPB_GUILO_SIZER_PARENT_PANEL				= $00000200
#AWPB_GUILO_SIZER_HAS_MINSIZE_VAL			= $00000400
#AWPB_GUILO_SIZER_HAS_MAXSIZE_VAL			= $00000800
#AWPB_GUILO_SIZER_HAS_MINSIZE_FUNC		= $00001000
#AWPB_GUILO_SIZER_HAS_MAXSIZE_FUNC		= $00002000

#AWPB_GUILO_SIZER_ALIGN_DEFAULT				= $00000000
#AWPB_GUILO_SIZER_ALIGN_LEFT					= $00000001
#AWPB_GUILO_SIZER_ALIGN_CENTER				= $00000002
#AWPB_GUILO_SIZER_ALIGN_RIGHT					= $00000004
#AWPB_GUILO_SIZER_ALIGN_TOP						= $00000008
#AWPB_GUILO_SIZER_ALIGN_MIDDLE				= $00000010
#AWPB_GUILO_SIZER_ALIGN_BOTTOM				= $00000020

#AWPB_GUILO_SIZER_ALIGN_TOPLEFT				= #AWPB_GUILO_SIZER_ALIGN_LEFT   | #AWPB_GUILO_SIZER_ALIGN_TOP
#AWPB_GUILO_SIZER_ALIGN_TOPCENTER			= #AWPB_GUILO_SIZER_ALIGN_CENTER | #AWPB_GUILO_SIZER_ALIGN_TOP
#AWPB_GUILO_SIZER_ALIGN_TOPRIGHT			= #AWPB_GUILO_SIZER_ALIGN_RIGHT	 | #AWPB_GUILO_SIZER_ALIGN_TOP
#AWPB_GUILO_SIZER_ALIGN_MIDDLELEFT		= #AWPB_GUILO_SIZER_ALIGN_LEFT   | #AWPB_GUILO_SIZER_ALIGN_MIDDLE
#AWPB_GUILO_SIZER_ALIGN_MIDDLECENTER	= #AWPB_GUILO_SIZER_ALIGN_CENTER | #AWPB_GUILO_SIZER_ALIGN_MIDDLE
#AWPB_GUILO_SIZER_ALIGN_MIDDLERIGHT		= #AWPB_GUILO_SIZER_ALIGN_RIGHT  | #AWPB_GUILO_SIZER_ALIGN_MIDDLE
#AWPB_GUILO_SIZER_ALIGN_BOTTOMLEFT		= #AWPB_GUILO_SIZER_ALIGN_LEFT   | #AWPB_GUILO_SIZER_ALIGN_BOTTOM
#AWPB_GUILO_SIZER_ALIGN_BOTTOMCENTER	= #AWPB_GUILO_SIZER_ALIGN_CENTER | #AWPB_GUILO_SIZER_ALIGN_BOTTOM
#AWPB_GUILO_SIZER_ALIGN_BOTTOMRIGHT		= #AWPB_GUILO_SIZER_ALIGN_RIGHT  | #AWPB_GUILO_SIZER_ALIGN_BOTTOM

#AWPB_GUILO_GETWIDTH									= #AWPB_GUILO_SIZER_VBOX
#AWPB_GUILO_GETHEIGHT									= #AWPB_GUILO_SIZER_HBOX
;}
;{ CallBack Prototypes
PrototypeC 	 AWPB_GUILO_OnBeforeResize_Proto(GadgetID.i)
PrototypeC 	 AWPB_GUILO_OnAfterResize_Proto(GadgetID.i, Left.i, Top.i, Width.i, Height.i)
PrototypeC.i AWPB_GUILO_GetMinGadgetSize_Proto(GadgetID.i, Flag.i)
PrototypeC.i AWPB_GUILO_GetMaxGadgetSize_Proto(GadgetID.i, Flag.i)
;}
;{ Support Procedures
;{ System dependent data
CompilerIf #PB_Compiler_OS = #PB_OS_Linux
	Structure ____AWPB_Gadget
		*Gadget.GtkWidget
		*Container.GtkWidget
		*VT
		UserData.i
		GadgetData.i[4]
	EndStructure
CompilerEndIf
;}
Procedure.i ____AWPB_GetGadgetTextHeight(GadgetID.i)
	CompilerSelect #PB_Compiler_OS
		CompilerCase #PB_OS_Linux
			Protected *Frame.GtkFrame, *Widget.GtkWidget, h
	 
			*Frame = GadgetID(GadgetID)
			If *Frame
				*Widget = gtk_frame_get_label_widget_(*Frame)
				If *Widget
					gtk_widget_get_size_request_(*Widget, #Null, @h)
					h - 10
					ProcedureReturn h
				EndIf
			EndIf
		CompilerCase #PB_OS_Windows
		  Protected *otm.OUTLINETEXTMETRIC, bsize.i, Font.i, hWnd.i, hdc.i, FontSize.i
  
  		hWnd  = GadgetID(GadgetID)
  	  Font  = GetGadgetFont(GadgetID) 
  		hdc   = GetDC_(hWnd)
  		Font  = SelectObject_(hdc, Font)
  		bsize = GetOutlineTextMetrics_(hdc, 0, 0)
  
  		If bsize = 0
    		SelectObject_(hdc, Font)
    		ReleaseDC_(hWnd, hdc)
    		ProcedureReturn 0
  		EndIf
  
  		*otm 				 = AllocateMemory(bsize)
  		*otm\otmSize = bsize
  
		  GetOutlineTextMetrics_(hdc, bsize, *otm)

  		FontSize = Int(Round((*otm\otmTextMetrics\tmHeight * 72.0 / GetDeviceCaps_(hdc, #LOGPIXELSY)), 1))
  
  		FreeMemory(*otm)
  		SelectObject_(hdc, Font)
  		ReleaseDC_(hWnd,hdc)

  		ProcedureReturn FontSize * 2
	CompilerEndSelect
	
	ProcedureReturn 0	
EndProcedure
Procedure.b ____AWPB_GetLMBState(Window.i)
	CompilerSelect #PB_Compiler_OS
		CompilerCase #PB_OS_Linux
			Protected *GdkWin.GTKWindow, x.i, y.i, mask.i
			
			If IsWindow(Window)
				*GdkWin = WindowID(Window)
				gdk_window_get_pointer_(*GdkWin\bin\child\window, @x, @y, @mask)
				
				If mask & #GDK_BUTTON1_MASK
					ProcedureReturn #True
				EndIf
			EndIf
		CompilerCase #PB_OS_Windows
			If IsWindow(Window) And GetForegroundWindow_() = Window
				If GetAsyncKeyState_(#VK_LBUTTON) > 0
					ProcedureReturn #True
				EndIf
			EndIf
	CompilerEndSelect
	
	ProcedureReturn #False
EndProcedure
Procedure.b ____AWPB_GetRMBState(Window.i)
	CompilerSelect #PB_Compiler_OS
		CompilerCase #PB_OS_Linux
			Protected *GdkWin.GTKWindow, x.i, y.i, mask.i
			
			If IsWindow(Window)
				*GdkWin = WindowID(Window)
				gdk_window_get_pointer_(*GdkWin\bin\child\window, @x, @y, @mask)
				
				If mask & #GDK_BUTTON3_MASK
					ProcedureReturn #True
				EndIf
			EndIf
		CompilerCase #PB_OS_Windows
			If IsWindow(Window) And GetForegroundWindow_() = Window
				If GetAsyncKeyState_(#VK_RBUTTON) > 0
					ProcedureReturn #True
				EndIf
			EndIf
	CompilerEndSelect
	
	ProcedureReturn #False
EndProcedure
Procedure.b ____AWPB_GetMMBState(Window.i)
	CompilerSelect #PB_Compiler_OS
		CompilerCase #PB_OS_Linux
			Protected *GdkWin.GTKWindow, x.i, y.i, mask.i
			
			If IsWindow(Window)
				*GdkWin = WindowID(Window)
				gdk_window_get_pointer_(*GdkWin\bin\child\window, @x, @y, @mask)
				
				If mask & #GDK_BUTTON2_MASK
					ProcedureReturn #True
				EndIf
			EndIf
		CompilerCase #PB_OS_Windows
			If IsWindow(Window) And GetForegroundWindow_() = Window
				If GetAsyncKeyState_(#VK_MBUTTON) > 0
					ProcedureReturn #True
				EndIf
			EndIf
	CompilerEndSelect
	
	ProcedureReturn #False
EndProcedure
Procedure   ____AWPB_GetRequiredSize(Gadget, *Width.LONG, *Height.LONG, Flags = 0)
	CompilerSelect #PB_Compiler_OS
		CompilerCase #PB_OS_Windows
			Protected DC, oldFont, Size.SIZE, text.s, line.s, LineSize.SIZE, count, empty, maxheight, index
			
			DC      = GetDC_(GadgetID(Gadget))
			oldFont = SelectObject_(DC, GetGadgetFont(Gadget)) 
			
			Select GadgetType(Gadget)
				Case #PB_GadgetType_Text
					Text      = RemoveString(GetGadgetText(Gadget), Chr(10))
					count     = CountString(Text, Chr(13)) + 1
					empty     = 0
					maxheight = 0 
					For index = 1 To count 
						Line = StringField(Text, index, Chr(13))
						If Line = "" 
							empty + 1
						Else 
							GetTextExtentPoint32_(DC, @Line, Len(Line), LineSize)
							Size\cx   = Max(Size\cx, LineSize\cx)
							Size\cy   + LineSize\cy
							maxheight = Max(maxheight, LineSize\cy)
						EndIf
					Next index            
					Size\cy + empty * maxheight  
					
					If Flags & #PB_Text_Border
						Size\cx + GetSystemMetrics_(#SM_CXEDGE) * 2
						Size\cy + GetSystemMetrics_(#SM_CYEDGE) * 2
					Else           
						Size\cx + 2
						Size\cy + 2
					EndIf	
				Case #PB_GadgetType_CheckBox, #PB_GadgetType_Option
					Text = GetGadgetText(Gadget)
					GetTextExtentPoint32_(DC, @Text, Len(Text), @Size)
					Size\cx + 20
					Size\cy = Max(Size\cy+2, 20)					
				Case #PB_GadgetType_Button
					Text = GetGadgetText(Gadget)
					GetTextExtentPoint32_(DC, @Text, Len(Text), @Size)
					Size\cx + GetSystemMetrics_(#SM_CXEDGE)*2
					Size\cy = Max(Size\cy+GetSystemMetrics_(#SM_CYEDGE)*2, 24)
					Size\cx + 10					
				Case #PB_GadgetType_String
					Text = GetGadgetText(Gadget) + "Hg" 
					GetTextExtentPoint32_(DC, @Text, Len(Text), @Size)
					Size\cx = GetSystemMetrics_(#SM_CXEDGE)*2 
					Size\cy = Max(Size\cy+GetSystemMetrics_(#SM_CXEDGE)*2, 20)					
				Case #PB_GadgetType_ComboBox
					GetTextExtentPoint32_(DC, @"Hg", 2, @Size)
					Size\cy = Max(Size\cy + 8, 21)
					Size\cx = Size\cy  					
				Case #PB_GadgetType_Image
					Size\cx = GadgetWidth(Gadget)
					Size\cy = GadgetHeight(Gadget)					
				Default	;- TODO
					Size\cx = 20
					Size\cy = 20
			EndSelect
			
			SelectObject_(DC, oldFont)
			ReleaseDC_(GadgetID(Gadget), DC)
			*Width\l  = Size\cx
			*Height\l = Size\cy
		
		CompilerCase #PB_OS_Linux
			Protected *Gadget.____AWPB_Gadget, RealSize.GtkRequisition, Size.GtkRequisition
			
			*Gadget = IsGadget(Gadget)
			If *Gadget And *Gadget\Container And GadgetType(Gadget) <> #PB_GadgetType_ComboBox
				gtk_widget_size_request_(*Gadget\Container, @RealSize)
				gtk_widget_set_size_request_(*Gadget\Container, -1, -1)
				gtk_widget_size_request_(*Gadget\Container, @Size)      
				gtk_widget_set_size_request_(*Gadget\Container, RealSize\Width, RealSize\Height) 
			Else
				gtk_widget_size_request_(GadgetID(Gadget), @RealSize)
				gtk_widget_set_size_request_(GadgetID(Gadget), -1, -1)              
				gtk_widget_size_request_(GadgetID(Gadget), @Size)    
				gtk_widget_set_size_request_(GadgetID(Gadget), RealSize\Width, RealSize\Height)
			EndIf
			
			If GadgetType(Gadget) = #PB_GadgetType_ComboBox Or GadgetType(Gadget) = #PB_GadgetType_String
				*Width\l  = 20 
			Else
				*Width\l  = Size\Width
			EndIf
					
			*Height\l 	= Size\Height    
	CompilerEndSelect
EndProcedure

;}
;{ Support Macros
Macro ____AWPB_IsFlag(X, Y)
	(((X) & (Y)) = Y)
EndMacro
CompilerIf Defined(Max, #PB_Procedure) = 0
	Procedure Max(a, b)
		If a > b
			ProcedureReturn a
		Else
			ProcedureReturn b
		EndIf
	EndProcedure
CompilerEndIf
CompilerIf Defined(Min, #PB_Procedure) = 0
	Procedure Min(a, b)
		If a < b
			ProcedureReturn a
		Else
			ProcedureReturn b
		EndIf
	EndProcedure
CompilerEndIf
;}
;{ Support Structures
Structure AWPB_GUILO_Sizer_Gadget
	ParentSizer.i
	Size.i
	MinWidth.i
	MaxWidth.i
	MinHeight.i
	MaxHeight.i
	Flags.i
	Align.i
	GadgetID.i
	BorderLeft.i
	BorderTop.i
	BorderRight.i
	BorderBottom.i
	*OnBeforeResizeCallback.AWPB_GUILO_OnBeforeResize_Proto
	*OnAfterResizeCallback.AWPB_GUILO_OnAfterResize_Proto
	*GetMinGadgetSize.AWPB_GUILO_GetMinGadgetSize_Proto
	*GetMaxGadgetSize.AWPB_GUILO_GetMaxGadgetSize_Proto	
EndStructure
Structure AWPB_GUILO_Sizer_FramedSizer Extends AWPB_GUILO_Sizer_Gadget
	InnerBorderLeft.i
	InnerBorderTop.i
	InnerBorderRight.i
	InnerBorderBottom.i
EndStructure
Structure ____AWPB_GUILO_Size
	MinW.i
	MinH.i
	MaxW.i
	MaxH.i
EndStructure
;}
;{ Sizer Object
Interface AWPB_GUILO_Sizer
	Destroy      				()
	Finish.b     				(ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	Resize       				(ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	AddGadgetEx.b				(*Gadget.AWPB_GUILO_Sizer_Gadget)
	AddGadget.b					(ParentSizer.i, GadgetID.i, Size.i)
	AddSizer.i					(ParentSizer.i, Flags.i, Size.i)
	AddSpacer.b					(ParentSizer.i, Size.i)
	AddFramedSizerEx.i	(*Frame.AWPB_GUILO_Sizer_FramedSizer)
	AddFramedSizer.i		(ParentSizer.i, GadgetID.i, Flags.i, Size.i)
	MinWidth.i   				(ParentSizer.i = #Null)
	MaxWidth.i   				(ParentSizer.i = #Null)
	MinHeight.i  				(ParentSizer.i = #Null)
	MaxHeight.i  				(ParentSizer.i = #Null)
EndInterface
Structure ____AWPB_GUILO_Sizer_Data
	; calculated values
	l.i
	t.i
	r.i
	b.i
	w.i
	h.i
	MinMax.____AWPB_GUILO_Size
	GdgMinMax.____AWPB_GUILO_Size
	
	; given values
	flags.i			; #AWPB_GUILO_SIZER_GADGET | #AWPB_GUILO_SIZER_SPACER | #AWPB_GUILO_SIZER_SIZER | #AWPB_GUILO_SIZER_FRAME | #AWPB_GUILO_SIZER_VBOX | #AWPB_GUILO_SIZER_HBOX	| WPB_GUILO_SIZER_HAS_MINSIZE_VAL	| AWPB_GUILO_SIZER_HAS_MAXSIZE_VAL | WPB_GUILO_SIZER_HAS_MINSIZE_FUNC	| AWPB_GUILO_SIZER_HAS_MAXSIZE_FUNC
	size.i			; 0... px | 0..100 %
	bleft.i			; Outer Border Left
	btop.i			; Outer Border Top
	bright.i		; Outer Border Right
	bbottom.i		; Outer Border Bottom
	ibleft.i		; Inner Border Left
	ibtop.i			; Inner Border Top
	ibright.i		; Inner Border Right
	ibbottom.i	; Inner Border Bottom
	GadgetID.i	; Gadget Number if needed
	MaxWidth.i	; maximum size in pixels (0 - default, >0 - user defined; Flag must be set)
	MinWidth.i  ; minimum size in pixels (0 - default, >0 - user defined; Flag must be set)
	MaxHeight.i	; maximum size in pixels (0 - default, >0 - user defined; Flag must be set)
	MinHeight.i ; minimum size in pixels (0 - default, >0 - user defined; Flag must be set)
	Align.i			; alignment if gadget smaller than sizer
	
	*OnBeforeResize.AWPB_GUILO_OnBeforeResize_Proto
	*OnAfterResize.AWPB_GUILO_OnAfterResize_Proto
	
	*GetMinGadgetSize.AWPB_GUILO_GetMinGadgetSize_Proto
	*GetMaxGadgetSize.AWPB_GUILO_GetMaxGadgetSize_Proto	
	
	List *childs.____AWPB_GUILO_Sizer_Data()
	
	; Internal Flags
	*ReliesOn
	Process.b	
EndStructure
Structure ____AWPB_GUILO_Sizer
	*vt.____AWPB_GUILO_Sizer_VT
	
	sizers.____AWPB_GUILO_Sizer_Data
	
	ParentID.i
EndStructure

Procedure.i AWPB_CreateSizerObj(ParentID.i)
	Protected *this.____AWPB_GUILO_Sizer
	
	If Not IsWindow(ParentID)
		If Not IsGadget(ParentID)
			ProcedureReturn #Null
		EndIf
		If (GadgetType(ParentID) <> #PB_GadgetType_Container) And (GadgetType(ParentID) <> #PB_GadgetType_Frame3D) And (GadgetType(ParentID) <> #PB_GadgetType_Panel)
			ProcedureReturn #Null
		EndIf
	EndIf
	
	*this = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer))
	If *this 
		InitializeStructure(*this, ____AWPB_GUILO_Sizer)
		*this\vt              = ?____AWPB_GUILO_Sizer_VT
		*this\ParentID        = ParentID
		*this\sizers\l        = 0
		*this\sizers\t        = 0
		
		If IsWindow(ParentID)
			*this\sizers\Flags = #AWPB_GUILO_SIZER_PARENT_WINDOW
      *this\sizers\r     = WindowWidth(ParentID)
      *this\sizers\b     = WindowHeight(ParentID)
    ElseIf IsGadget(ParentID)
    	If GadgetType(ParentID) = #PB_GadgetType_Container
    		*this\sizers\Flags = #AWPB_GUILO_SIZER_PARENT_CONTAINER
    	ElseIf GadgetType(ParentID) = #PB_GadgetType_Frame3D
    		*this\sizers\Flags = #AWPB_GUILO_SIZER_PARENT_FRAME
    	ElseIf GadgetType(ParentID) = #PB_GadgetType_Panel
    		*this\sizers\Flags = #AWPB_GUILO_SIZER_PARENT_PANEL
    	Else
	    	FreeMemory(*this)
	    	ProcedureReturn #Null
    	EndIf
      *this\sizers\r     = GadgetWidth(ParentID)
      *this\sizers\b     = GadgetHeight(ParentID)
    Else
    	FreeMemory(*this)
    	ProcedureReturn #Null
    EndIf
    *this\sizers\flags					| #AWPB_GUILO_SIZER_VBOX | #AWPB_GUILO_SIZER_SIZER
    *this\sizers\w        			= *this\sizers\r
		*this\sizers\h        			= *this\sizers\b
		*this\sizers\bleft   			  = 0
		*this\sizers\btop    			  =	0
		*this\sizers\bright   			= 0
		*this\sizers\bbottom  			= 0
		*this\sizers\ibleft   			= 0
		*this\sizers\ibtop    			= 0
		*this\sizers\ibright   			= 0
		*this\sizers\ibbottom  			= 0
		*this\sizers\GadgetID 			= #PB_Any
		*this\sizers\size     			= 100
		*this\sizers\OnBeforeResize = #Null
		*this\sizers\OnAfterResize  = #Null
		*this\sizers\Process 				= #False
		*this\sizers\ReliesOn				= #Null
		
		ProcedureReturn *this
	EndIf
	
	ProcedureReturn #Null
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_DestroyChild(*sizer.____AWPB_GUILO_Sizer_Data)
	ForEach *sizer\childs()
		____AWPB_GUILO_Sizer_DestroyChild(*sizer\childs())
	Next
	FreeList(*sizer\childs())
	FreeMemory(*sizer)
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_Destroy(*this.____AWPB_GUILO_Sizer)
	ForEach *this\sizers\childs()
		____AWPB_GUILO_Sizer_DestroyChild(*this\sizers\childs())
	Next
	FreeList(*this\sizers\childs())
	FreeMemory(*this)
EndProcedure
Procedure.b ____AWPB_GUILO_Sizer_CalculateChild(*sizer.____AWPB_GUILO_Sizer_Data, *MinMax.____AWPB_GUILO_Size) ; returns #False on oversize
	; wenn Gadget enthalten ist, dessen maximale gre ermitteln
	; dann alle enthaltenen sizer berprfen, und je nach ausrichtung den jeweiligen max/min-wert nehmen
	; in der zweiten Phase dann alles nochmal durchgehen und auf die vorberechneten werte setzen
	
	Protected res.b
	Protected ChildMinMax.____AWPB_GUILO_Size, minsz.i, maxsz.i
	
	Protected l.i, t.i, r.i, b.i, w.i, h.i, gl.i, gt.i, gb.i, gr.i, gw.i, gh.i, ol.i, ot.i, ow.i, oh.i
	
	res = #True
	
	If ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_GADGET) Or ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_FRAME)
		; wenn ein Gadget drin ist die Grenbeschrnkungen ermitteln
		
		If ____AWPB_IsFlag(*sizer\Flags, #AWPB_GUILO_SIZER_HAS_MINSIZE_FUNC)
			If *sizer\GetMinGadgetSize 
				*MinMax\MinW = *sizer\GetMinGadgetSize(*sizer\GadgetID, #AWPB_GUILO_GETWIDTH)
				*MinMax\MinH = *sizer\GetMinGadgetSize(*sizer\GadgetID, #AWPB_GUILO_GETHEIGHT)
			EndIf
		ElseIf ____AWPB_IsFlag(*sizer\Flags, #AWPB_GUILO_SIZER_HAS_MINSIZE_VAL)
			*MinMax\MinW = *sizer\MinWidth
			*MinMax\MinH = *sizer\MinHeight
		Else
			*MinMax\MinW = 0
			*MinMax\MinH = 0
		EndIf
		If ____AWPB_IsFlag(*sizer\Flags, #AWPB_GUILO_SIZER_HAS_MAXSIZE_FUNC)
			If *sizer\GetMaxGadgetSize 
				*MinMax\MaxW = *sizer\GetMaxGadgetSize(*sizer\GadgetID, #AWPB_GUILO_GETWIDTH)
				*MinMax\MaxH = *sizer\GetMaxGadgetSize(*sizer\GadgetID, #AWPB_GUILO_GETHEIGHT)
			EndIf
		ElseIf ____AWPB_IsFlag(*sizer\Flags, #AWPB_GUILO_SIZER_HAS_MAXSIZE_VAL)
			*MinMax\MaxW = *sizer\MaxWidth
			*MinMax\MaxH = *sizer\MaxHeight
		Else
			*MinMax\MaxW = $00FFFFFF
			*MinMax\MaxH = $00FFFFFF
		EndIf
		; -> diese Flche bentigt das Gadget zur Darstellung
	Else
		; kein Gadget im Sizer -> an dieser Stelle Gre erstmal egal
		
		*MinMax\MinW = 0
		*MinMax\MinH = 0			
		*MinMax\MaxW = $00FFFFFF
		*MinMax\MaxH = $00FFFFFF
	EndIf	
	; *MinMax enthlt die minimal/maximal gre des Gedgets an dieser stelle
	*sizer\GdgMinMax\MinW = *MinMax\MinW
	*sizer\GdgMinMax\MaxW = *MinMax\MaxW
	*sizer\GdgMinMax\MinH = *MinMax\MinH
	*sizer\GdgMinMax\MaxH = *MinMax\MaxH
	
	If ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_SIZER)
		; enthlt Child-Sizer
		; alle Childsizer untersuchen und die Maximalgre ermitteln
		If ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_HBOX)
			; horizontal - t, b and h static
			MinSZ = 0 : MaxSZ = 0
			ForEach *sizer\childs()
				With *sizer\childs()
					res   &  ____AWPB_GUILO_Sizer_CalculateChild(*sizer\childs(), @ChildMinMax)
					MinSZ + ChildMinMax\MinW
					MaxSZ + ChildMinMax\MaxW
					*MinMax\MinH = Max(ChildMinMax\MinH, *MinMax\MinH)
					*MinMax\MaxH = Max(ChildMinMax\MaxH, *MinMax\MaxH) ;- evtl Min ?
				EndWith
			Next
			*MinMax\MinW = Max(MinSZ, *MinMax\MinW)
			*MinMax\MaxW = Max(MaxSZ, *MinMax\MaxW)	;- evtl Min ?
		ElseIf ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_VBOX)
			; vertical - l, r and w static			
			MinSZ = 0 : MaxSZ = 0
			ForEach *sizer\childs()
				With *sizer\childs()
					res   &  ____AWPB_GUILO_Sizer_CalculateChild(*sizer\childs(), @ChildMinMax)
					MinSZ + ChildMinMax\MinH
					MaxSZ + ChildMinMax\MaxH
					*MinMax\MinW = Max(ChildMinMax\MinW, *MinMax\MinW)
					*MinMax\MaxW = Max(ChildMinMax\MaxW, *MinMax\MaxW) ;- evtl Min ?
				EndWith
			Next
			*MinMax\MinH = Max(MinSZ, *MinMax\MinH)
			*MinMax\MaxH = Max(MaxSZ, *MinMax\MaxH)	;- evtl Min ?
		EndIf
		
		If ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_FRAME)
			*MinMax\MinW + *sizer\ibleft + *sizer\ibright  + *sizer\bleft + *sizer\bright
			*MinMax\MaxW + *sizer\ibleft + *sizer\ibright  + *sizer\bleft + *sizer\bright
			*MinMax\MinH + *sizer\ibtop  + *sizer\ibbottom + *sizer\btop  + *sizer\bbottom
			*MinMax\MaxH + *sizer\ibtop  + *sizer\ibbottom + *sizer\btop  + *sizer\bbottom
		ElseIf ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_GADGET)
			*MinMax\MinW + *sizer\bleft + *sizer\bright
			*MinMax\MaxW + *sizer\bleft + *sizer\bright
			*MinMax\MinH + *sizer\btop  + *sizer\bbottom
			*MinMax\MaxH + *sizer\btop  + *sizer\bbottom
		EndIf			
	Else
		*MinMax\MinW + *sizer\bleft + *sizer\bright
		*MinMax\MaxW + *sizer\bleft + *sizer\bright
		*MinMax\MinH + *sizer\btop  + *sizer\bbottom
		*MinMax\MaxH + *sizer\btop  + *sizer\bbottom		
	EndIf
	
	*sizer\MinMax\MinW = *MinMax\MinW
	*sizer\MinMax\MaxW = *MinMax\MaxW
	*sizer\MinMax\MinH = *MinMax\MinH
	*sizer\MinMax\MaxH = *MinMax\MaxH
	
	ProcedureReturn res
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_FinishChild(*sizer.____AWPB_GUILO_Sizer_Data, ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b)
	Protected l.i, t.i, r.i, b.i, w.i, h.i, gl.i, gt.i, gb.i, gr.i, gw.i, gh.i, ol.i, ot.i, ow.i, oh.i, minsz.i, maxsz.i, nw.i, nh.i, al.i, at.i
	
	l = *sizer\l
	t = *sizer\t
	r = *sizer\r
	b = *sizer\b
	w = *sizer\w
	h = *sizer\h
	
	If ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_GADGET) Or ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_FRAME)
		If IsGadget(*sizer\GadgetID)
		  ol = l
		  ot = t
		  ow = w
		  oh = h
			gl = *sizer\l + *sizer\bleft
			gt = *sizer\t + *sizer\btop
			gr = *sizer\r - *sizer\bright
			gb = *sizer\b - *sizer\bbottom
			If gl > gr : gl = *sizer\l : EndIf
			If gt > gb : gl = *sizer\t : EndIf
			If gr < gl : gr = *sizer\r : EndIf
			If gb < gt : gb = *sizer\b : EndIf
			gw = gr - gl
			gh = gb - gt 
	    If (l <> ol) Or (t <> ot) Or (gw <> ow) Or (gh <> oh)
	  		If ExecuteBeforeResizeCallbacks 
		  	  If *sizer\OnBeforeResize <> #Null
			      *sizer\OnBeforeResize(*sizer\GadgetID)
			    EndIf  
			  EndIf  
			  nw = Max(*sizer\GdgMinMax\MinW, Min(*sizer\GdgMinMax\MaxW, gw))
			  nh = Max(*sizer\GdgMinMax\MinH, Min(*sizer\GdgMinMax\MaxH, gh))
			  al = gl
			  at = gt
			  If *sizer\Align
		  		If nw <> gw
		  			If ____AWPB_IsFlag(*sizer\Align, #AWPB_GUILO_SIZER_ALIGN_CENTER)
		  				al + ((gw - nw) >> 1)
		  			ElseIf ____AWPB_IsFlag(*sizer\Align, #AWPB_GUILO_SIZER_ALIGN_RIGHT)
		  				al + (gw - nw)
		  			EndIf
		  		EndIf
		  		If nh <> gh
		  			If ____AWPB_IsFlag(*sizer\Align, #AWPB_GUILO_SIZER_ALIGN_MIDDLE)
		  				at + ((gh - nh) >> 1)
		  			ElseIf ____AWPB_IsFlag(*sizer\Align, #AWPB_GUILO_SIZER_ALIGN_BOTTOM)
		  				at + (gh - nh)
		  			EndIf
		  		EndIf		  		
		  	EndIf
		  	
; Debug (GetGadgetText(*sizer\GadgetID))
; Debug ("Gadget: (" + Str(*sizer\GdgMinMax\MinW) + "x" + Str(*sizer\GdgMinMax\MinH) + ") - (" + Str(*sizer\GdgMinMax\MaxW) + "x" + Str(*sizer\GdgMinMax\MaxH) + ")" )
; Debug ("Sizer:  (" + Str(*sizer\MinMax\MinW) + "x" + Str(*sizer\MinMax\MinH) + ") - (" + Str(*sizer\MinMax\MaxW) + "x" + Str(*sizer\MinMax\MaxH) + ")" )
; Debug ("")

			  ResizeGadget(*sizer\GadgetID, al, at, nw, nh)
	  		If ExecuteAfterResizeCallbacks 
		  	  If *sizer\OnAfterResize <> #Null
			      *sizer\OnAfterResize(*sizer\GadgetID, al, at, nw, nh)
			    EndIf  
			  EndIf  
			EndIf
		EndIf
	EndIf
	If ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_SIZER)
		If ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_FRAME)
			With *sizer
				l = \l + \bleft   + \ibleft
				t = \t + \btop    + \ibtop
				r = \r - \bright  - \ibright
				b = \b - \bbottom - \ibbottom
				w = \w - \bleft   - \ibleft   - \bright  - \ibright
				h = \h - \btop    - \ibtop    - \bbottom - \ibbottom
			EndWith
		EndIf
		ForEach *sizer\childs()
			With *sizer\childs()
				If ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_HBOX)
					; horizontal - t, b and h static
					\t = t
					\b = b
					\h = h
					\l = l
					\w = (w * \size) / 100
					\r = \l + \w - 1
					l  = \r + 1
				ElseIf ____AWPB_IsFlag(*sizer\flags, #AWPB_GUILO_SIZER_VBOX)
					; vertical - l, r and w static
					\l = l
					\r = r
					\w = w
					\t = t
					\h = (h * \size) / 100
					\b = \t + \h - 1
					t  = \b + 1
				EndIf
			EndWith
			____AWPB_GUILO_Sizer_FinishChild(*sizer\childs(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
		Next
	EndIf
EndProcedure
Procedure.b ____AWPB_GUILO_Sizer_Finish(*this.____AWPB_GUILO_Sizer, ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	Protected res.b, MinMax.____AWPB_GUILO_Size
	
	res = ____AWPB_GUILO_Sizer_CalculateChild(@*this\sizers, @MinMax)
	____AWPB_GUILO_Sizer_FinishChild(@*this\sizers, ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
	
	ProcedureReturn res
EndProcedure
Procedure   ____AWPB_GUILO_Sizer_Resize(*this.____AWPB_GUILO_Sizer, ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	If ____AWPB_IsFlag(*this\sizers\flags, #AWPB_GUILO_SIZER_PARENT_WINDOW)
		*this\sizers\r        = WindowWidth(*this\ParentID)
    *this\sizers\b        = WindowHeight(*this\ParentID)
  ElseIf ____AWPB_IsFlag(*this\sizers\flags, #AWPB_GUILO_SIZER_PARENT_CONTAINER) Or ____AWPB_IsFlag(*this\sizers\flags, #AWPB_GUILO_SIZER_PARENT_FRAME)
    *this\sizers\r        = GadgetWidth(*this\ParentID)
    *this\sizers\b        = GadgetHeight(*this\ParentID)
  ElseIf ____AWPB_IsFlag(*this\sizers\flags, #AWPB_GUILO_SIZER_PARENT_PANEL)
  	*this\sizers\r        = GetGadgetAttribute(*this\ParentID, #PB_Panel_ItemWidth)
  	*this\sizers\b        = GetGadgetAttribute(*this\ParentID, #PB_Panel_ItemHeight)
	EndIf
	*this\sizers\w = *this\sizers\r
	*this\sizers\h = *this\sizers\b
	____AWPB_GUILO_Sizer_Finish(*this, ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
EndProcedure
Procedure.b ____AWPB_GUILO_Sizer_AddGadgetEx(*this.____AWPB_GUILO_Sizer, *Gadget.AWPB_GUILO_Sizer_Gadget)
	Protected *sizer.____AWPB_GUILO_Sizer_Data, *parent.____AWPB_GUILO_Sizer_Data
	
	If *Gadget
		If IsGadget(*Gadget\GadgetID)
			*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
			If *sizer
				InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
				With *sizer
					\flags          = *Gadget\Flags | #AWPB_GUILO_SIZER_GADGET
					\size     			= *Gadget\Size
					\bleft    			= *Gadget\BorderLeft
					\btop     			= *Gadget\BorderTop
					\bright   			= *Gadget\BorderRight
					\bbottom  			= *Gadget\BorderBottom
					\ibleft    			= 0
					\ibtop     			= 0
					\ibright   			= 0
					\ibbottom  			= 0
					\GadgetID 			= *Gadget\GadgetID
					\OnBeforeResize = *Gadget\OnBeforeResizeCallback
					\OnAfterResize  = *Gadget\OnAfterResizeCallback
					\Align					= *Gadget\Align
					
					If ____AWPB_IsFlag(*Gadget\Flags, #AWPB_GUILO_SIZER_HAS_MINSIZE_FUNC)
						If *Gadget\GetMinGadgetSize 
							\GetMinGadgetSize = *Gadget\GetMinGadgetSize
						EndIf
					EndIf
					If ____AWPB_IsFlag(*Gadget\Flags, #AWPB_GUILO_SIZER_HAS_MAXSIZE_FUNC)
						If *Gadget\GetMaxGadgetSize 
							\GetMaxGadgetSize = *Gadget\GetMaxGadgetSize
						EndIf
					EndIf
					If ____AWPB_IsFlag(*Gadget\Flags, #AWPB_GUILO_SIZER_HAS_MINSIZE_VAL)
						\MinWidth  = *Gadget\MinWidth
						\MinHeight = *Gadget\MinHeight
					EndIf
					If ____AWPB_IsFlag(*Gadget\Flags, #AWPB_GUILO_SIZER_HAS_MAXSIZE_VAL)
						\MaxWidth  = *Gadget\MaxWidth
						\MaxHeight = *Gadget\MaxHeight
					EndIf
				EndWith
				
				If *Gadget\ParentSizer
					*parent = *Gadget\ParentSizer
					AddElement(*parent\childs())
					*parent\childs() = *sizer
				Else
					AddElement(*this\sizers\childs())
					*this\sizers\childs() = *sizer
				EndIf
				
				ProcedureReturn #True
			EndIf
		EndIf
	EndIf
	
	ProcedureReturn #False
EndProcedure
Procedure.b ____AWPB_GUILO_Sizer_AddGadget(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, GadgetID.i, Size.i)
	Protected Gadget.AWPB_GUILO_Sizer_Gadget
	
	If IsGadget(GadgetID)
		InitializeStructure(@Gadget, AWPB_GUILO_Sizer_Gadget)
		With Gadget
			\GadgetID 		= GadgetID
			\Size					= Size
			\ParentSizer	= *ParentSizer
		EndWith
		
		ProcedureReturn ____AWPB_GUILO_Sizer_AddGadgetEx(*this, @Gadget)
	EndIf
	
	ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_AddSizer(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, Flags.i, Size.i)
	Protected *sizer.____AWPB_GUILO_Sizer_Data
	
	*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
	If *sizer
		InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
		With *sizer
			\flags					= #AWPB_GUILO_SIZER_SIZER
			If ____AWPB_IsFlag(Flags, #AWPB_GUILO_SIZER_HBOX)
				\flags				| #AWPB_GUILO_SIZER_HBOX
			Else
				\flags				| #AWPB_GUILO_SIZER_VBOX
			EndIf
			\size     			= Size
			\bleft    			= 0
			\btop     			= 0
			\bright   			= 0
			\bbottom  			= 0
			\ibleft    			= 0
			\ibtop     			= 0
			\ibright   			= 0
			\ibbottom  			= 0
			\GadgetID 			= #PB_Any
			\OnBeforeResize = #Null
			\OnAfterResize  = #Null
		EndWith
		
		If *ParentSizer
			AddElement(*ParentSizer\childs())
			*ParentSizer\childs() = *sizer
		Else
			AddElement(*this\sizers\childs())
			*this\sizers\childs() = *sizer
		EndIf
	EndIf
	
	ProcedureReturn *sizer		
EndProcedure
Procedure.b ____AWPB_GUILO_Sizer_AddSpacer(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, Size.i)
	Protected *sizer.____AWPB_GUILO_Sizer_Data
	
	*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
	If *sizer
		InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
		With *sizer
			\flags					= #AWPB_GUILO_SIZER_SPACER
			\size     			= Size
			\bleft    			= 0
			\btop     			= 0
			\bright   			= 0
			\bbottom  			= 0
			\ibleft    			= 0
			\ibtop     			= 0
			\ibright   			= 0
			\ibbottom  			= 0
			\GadgetID 			= #PB_Any
			\OnBeforeResize = #Null
			\OnAfterResize  = #Null
		EndWith
		
		If *ParentSizer
			AddElement(*ParentSizer\childs())
			*ParentSizer\childs() = *sizer
		Else
			AddElement(*this\sizers\childs())
			*this\sizers\childs() = *sizer
		EndIf
		
		ProcedureReturn #True
	EndIf
	
	ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_AddFramedSizerEx(*this.____AWPB_GUILO_Sizer, *Frame.AWPB_GUILO_Sizer_FramedSizer)
	Protected *sizer.____AWPB_GUILO_Sizer_Data, *parent.____AWPB_GUILO_Sizer_Data
	
	If *Frame
		If IsGadget(*Frame\GadgetID)
			If GadgetType(*Frame\GadgetID) = #PB_GadgetType_Frame3D				
				*sizer = AllocateMemory(SizeOf(____AWPB_GUILO_Sizer_Data))
				If *sizer
					InitializeStructure(*sizer, ____AWPB_GUILO_Sizer_Data)
					With *sizer
						\flags          = *Frame\Flags | #AWPB_GUILO_SIZER_SIZER | #AWPB_GUILO_SIZER_FRAME
						If Not ____AWPB_IsFlag(*Frame\Flags, #AWPB_GUILO_SIZER_HBOX) And Not ____AWPB_IsFlag(*Frame\Flags, #AWPB_GUILO_SIZER_VBOX)
							\flags				| #AWPB_GUILO_SIZER_VBOX
						EndIf
						\size     			= *Frame\Size
						\bleft    			= *Frame\BorderLeft
						\btop     			= *Frame\BorderTop
						\bright   			= *Frame\BorderRight
						\bbottom  			= *Frame\BorderBottom
						\ibleft    			= *Frame\InnerBorderLeft
						\ibtop     			= *Frame\InnerBorderTop
						\ibright   			= *Frame\InnerBorderRight
						\ibbottom  			= *Frame\InnerBorderBottom
						\GadgetID 			= *Frame\GadgetID
						\OnBeforeResize = *Frame\OnBeforeResizeCallback
						\OnAfterResize  = *Frame\OnAfterResizeCallback
						\Align					= *Frame\Align
						
						If ____AWPB_IsFlag(*Frame\Flags, #AWPB_GUILO_SIZER_HAS_MINSIZE_FUNC)
							If *Frame\GetMinGadgetSize 
								\GetMinGadgetSize = *Frame\GetMinGadgetSize
							EndIf
						EndIf
						If ____AWPB_IsFlag(*Frame\Flags, #AWPB_GUILO_SIZER_HAS_MAXSIZE_FUNC)
							If *Frame\GetMaxGadgetSize 
								\GetMaxGadgetSize = *Frame\GetMaxGadgetSize
							EndIf
						EndIf
						If ____AWPB_IsFlag(*Frame\Flags, #AWPB_GUILO_SIZER_HAS_MINSIZE_VAL)
							\MinWidth  = *Frame\MinWidth
							\MinHeight = *Frame\MinHeight
						EndIf
						If ____AWPB_IsFlag(*Frame\Flags, #AWPB_GUILO_SIZER_HAS_MAXSIZE_VAL)
							\MaxWidth  = *Frame\MaxWidth
							\MaxHeight = *Frame\MaxHeight
						EndIf

						If \ibbottom = #PB_Any : \ibbottom = 5 : EndIf
						If \ibleft   = #PB_Any : \ibleft   = 5 : EndIf
						If \ibright  = #PB_Any : \ibright  = 5 : EndIf
						If \ibtop    = #PB_Any
							If GetGadgetText(\GadgetID) <> "" 
								\ibtop = ____AWPB_GetGadgetTextHeight(\GadgetID)
							Else
								\ibtop = 5
							EndIf
						EndIf
					EndWith
					
					If *Frame\ParentSizer
						*parent = *Frame\ParentSizer
						AddElement(*parent\childs())
						*parent\childs() = *sizer
					Else
						AddElement(*this\sizers\childs())
						*this\sizers\childs() = *sizer
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	
	ProcedureReturn *sizer		
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_AddFramedSizer(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data, GadgetID.i, Flags.i, Size.i)
	Protected Frame.AWPB_GUILO_Sizer_FramedSizer
	
	If IsGadget(GadgetID)
		InitializeStructure(@Frame, AWPB_GUILO_Sizer_FramedSizer)
		With Frame
			\GadgetID 		= GadgetID
			\Size					= Size
			\ParentSizer	= *ParentSizer
			\Flags				= Flags
		EndWith
		
		ProcedureReturn ____AWPB_GUILO_Sizer_AddFramedSizerEx(*this, @Frame)
	EndIf
	
	ProcedureReturn #Null
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_MinWidth(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data = #Null)
	If *ParentSizer
		ProcedureReturn *ParentSizer\MinMax\MinW
	Else
		ProcedureReturn *this\sizers\MinMax\MinW
	EndIf
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_MaxWidth(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data = #Null)
	If *ParentSizer
		ProcedureReturn *ParentSizer\MinMax\MaxW
	Else
		ProcedureReturn *this\sizers\MinMax\MaxW
	EndIf
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_MinHeight(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data = #Null)
	If *ParentSizer
		ProcedureReturn *ParentSizer\MinMax\MinH
	Else
		ProcedureReturn *this\sizers\MinMax\MinH
	EndIf
EndProcedure
Procedure.i ____AWPB_GUILO_Sizer_MaxHeight(*this.____AWPB_GUILO_Sizer, *ParentSizer.____AWPB_GUILO_Sizer_Data = #Null)
	If *ParentSizer
		ProcedureReturn *ParentSizer\MinMax\MaxH
	Else
		ProcedureReturn *this\sizers\MinMax\MaxH
	EndIf
EndProcedure
 
DataSection ;{
____AWPB_GUILO_Sizer_VT:
  Data.i @____AWPB_GUILO_Sizer_Destroy()
  Data.i @____AWPB_GUILO_Sizer_Finish()
  Data.i @____AWPB_GUILO_Sizer_Resize()
  Data.i @____AWPB_GUILO_Sizer_AddGadgetEx()
  Data.i @____AWPB_GUILO_Sizer_AddGadget()
  Data.i @____AWPB_GUILO_Sizer_AddSizer()
  Data.i @____AWPB_GUILO_Sizer_AddSpacer()
  Data.i @____AWPB_GUILO_Sizer_AddFramedSizerEx()
  Data.i @____AWPB_GUILO_Sizer_AddFramedSizer()
  Data.i @____AWPB_GUILO_Sizer_MinWidth()
  Data.i @____AWPB_GUILO_Sizer_MaxWidth()
  Data.i @____AWPB_GUILO_Sizer_MinHeight()  
  Data.i @____AWPB_GUILO_Sizer_MaxHeight()  
EndDataSection ;}
;}
;{ SizerList Object
Interface AWPB_GUILO_SizerList
	Destroy      			()
	AllocateSizer.i		(ParentID.i, *ReliesOnSizer = #Null)
	FreeSizer					(*Sizer.AWPB_GUILO_Sizer)
	Finish	     			(ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)	
	Resize       			(ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
EndInterface
Structure ____AWPB_GUILO_SizerList
	*vt.____AWPB_GUILO_SizerList_VT
	
	Map *childs.AWPB_GUILO_Sizer()
EndStructure

Procedure.i AWPB_CreateSizerListObj()
	Protected *this.____AWPB_GUILO_SizerList
		
	*this = AllocateMemory(SizeOf(____AWPB_GUILO_SizerList))
	If *this 
		InitializeStructure(*this, ____AWPB_GUILO_SizerList)
		*this\vt = ?____AWPB_GUILO_SizerList_VT
		
		ProcedureReturn *this
	EndIf
	
	ProcedureReturn #Null
EndProcedure
Procedure   ____AWPB_GUILO_SizerList_Destroy(*this.____AWPB_GUILO_SizerList)
	Protected *sz.AWPB_GUILO_Sizer
	
	ForEach *this\childs()
		*sz = *this\childs()
		*sz\Destroy()
	Next

	FreeMap(*this\childs())
	FreeMemory(*this)
EndProcedure
Procedure.i ____AWPB_GUILO_SizerList_AllocateSizer(*this.____AWPB_GUILO_SizerList, ParentID.i, *ReliesOnSizer)
	Protected *sz.AWPB_GUILO_Sizer, *szd.____AWPB_GUILO_Sizer
	
	*sz = AWPB_CreateSizerObj(ParentID)
	If *sz
		*szd                 = *sz
		*szd\sizers\ReliesOn = *ReliesOnSizer
		AddMapElement(*this\childs(), Str(*sz))
		*this\childs()       = *sz
	EndIf
	
	ProcedureReturn *sz
EndProcedure
Procedure   ____AWPB_GUILO_SizerList_FreeSizer(*this.____AWPB_GUILO_SizerList, *Sizer.AWPB_GUILO_Sizer)
	If *Sizer
		*Sizer\Destroy()
		DeleteMapElement(*this\childs(), Str(*Sizer))
	EndIf
EndProcedure
Procedure   ____AWPB_GUILO_SizerList_FinishSizer(Map *sizers.AWPB_GUILO_Sizer(), ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b, key.s = "")
	Protected *szd.____AWPB_GUILO_Sizer, *sz.AWPB_GUILO_Sizer
	
	If key = ""
		ForEach(*sizers())
			*szd = *sizers()
			If *szd
				If *szd\sizers\Process
					PushMapPosition(*sizers())
					____AWPB_GUILO_SizerList_FinishSizer(*sizers(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks, MapKey(*sizers()))
					PopMapPosition(*sizers())
				EndIf
			EndIf
		Next
	Else
		If FindMapElement(*sizers(), key)
			*szd = *sizers()
			If *szd
				If *szd\sizers\Process
					If *szd\sizers\ReliesOn
						____AWPB_GUILO_SizerList_FinishSizer(*sizers(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks, Str(*szd\sizers\ReliesOn))
					EndIf
					*szd\sizers\Process = #False
					*sz                 = *szd
					*sz\Finish(ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
				EndIf
			EndIf
		EndIf
	EndIf
EndProcedure
Procedure   ____AWPB_GUILO_SizerList_Finish(*this.____AWPB_GUILO_SizerList, ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	Protected *szd.____AWPB_GUILO_Sizer
	
	ForEach *this\childs()
		*szd = *this\childs()
		*szd\sizers\Process = #True
	Next
	____AWPB_GUILO_SizerList_FinishSizer(*this\childs(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks, "")
EndProcedure
Procedure   ____AWPB_GUILO_SizerList_ResizeSizer(Map *sizers.AWPB_GUILO_Sizer(), ExecuteBeforeResizeCallbacks.b, ExecuteAfterResizeCallbacks.b, key.s = "")
	Protected *szd.____AWPB_GUILO_Sizer, *sz.AWPB_GUILO_Sizer
	
	If key = ""
		ForEach(*sizers())
			*szd = *sizers()
			If *szd
				If *szd\sizers\Process
					PushMapPosition(*sizers())
					____AWPB_GUILO_SizerList_ResizeSizer(*sizers(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks, MapKey(*sizers()))
					PopMapPosition(*sizers())
				EndIf
			EndIf
		Next
	Else
		If FindMapElement(*sizers(), key)
			*szd = *sizers()
			If *szd
				If *szd\sizers\Process
					If *szd\sizers\ReliesOn
						____AWPB_GUILO_SizerList_ResizeSizer(*sizers(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks, Str(*szd\sizers\ReliesOn))
					EndIf
					*szd\sizers\Process = #False
					*sz                 = *szd
					*sz\Resize(ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks)
				EndIf
			EndIf
		EndIf
	EndIf
EndProcedure
Procedure   ____AWPB_GUILO_SizerList_Resize(*this.____AWPB_GUILO_SizerList, ExecuteBeforeResizeCallbacks.b = #False, ExecuteAfterResizeCallbacks.b = #False)
	Protected *szd.____AWPB_GUILO_Sizer
	
	ForEach *this\childs()
		*szd = *this\childs()
		*szd\sizers\Process = #True
	Next
	____AWPB_GUILO_SizerList_ResizeSizer(*this\childs(), ExecuteBeforeResizeCallbacks, ExecuteAfterResizeCallbacks, "")
EndProcedure

DataSection ;{
____AWPB_GUILO_SizerList_VT:
  Data.i @____AWPB_GUILO_SizerList_Destroy()
  Data.i @____AWPB_GUILO_SizerList_AllocateSizer()
  Data.i @____AWPB_GUILO_SizerList_FreeSizer()
  Data.i @____AWPB_GUILO_SizerList_Finish()
  Data.i @____AWPB_GUILO_SizerList_Resize()
EndDataSection ;}
;}

